package it.cavallium.strangedb.java.objects.lists.operations;

import it.cavallium.strangedb.java.objects.lists.KMP;
import it.cavallium.strangedb.java.objects.lists.ValueOperation;

public class ContainsIgnoreCase implements ValueOperation<String> {

	private final CharSequence containsValue;

	private ContainsIgnoreCase(CharSequence containsValue) {
		this.containsValue = containsValue;
	}

	public static ContainsIgnoreCase containsValue(CharSequence value) {
		return new ContainsIgnoreCase(value);
	}

	@Override
	public boolean evaluate(Object value) {
		if (value instanceof CharSequence) {
			return KMP.KMP( (CharSequence) value, containsValue, true) != -1;
		}
		return false;
	}
}
