package it.cavallium.strangedb.java.objects.lists.operations;

import it.cavallium.strangedb.java.objects.lists.ValueOperation;

public class Equals<T> implements ValueOperation<T> {

	private final T equalToValue;

	private Equals(T equalToValue) {
		this.equalToValue = equalToValue;
	}

	public static <T> Equals<T> to(T value) {
		return new Equals<T>(value);
	}

	@Override
	public boolean evaluate(Object value) {
		return equalToValue.equals(value);
	}
}
