package it.cavallium.strangedb.tests;

import it.cavallium.strangedb.java.annotations.DbDataType;
import it.cavallium.strangedb.java.annotations.DbField;
import it.cavallium.strangedb.java.database.IDatabaseTools;
import it.cavallium.strangedb.java.objects.EnhancedObject;

import java.io.IOException;
import java.util.StringJoiner;

public class User extends EnhancedObject {

	@DbField(id = 0, name = "firstName")
	public String firstName;

	@DbField(id = 1, name = "username")
	public String username;

	@DbField(id = 2, type = DbDataType.ENHANCED_OBJECT, name = "fullInfo")
	public UserFullInfo fullInfo;

	public User() {
	}

	public User(IDatabaseTools databaseTools, String firstName, String username, String bio) throws IOException {
		super(databaseTools);
		this.firstName = firstName;
		this.username = username;
		this.fullInfo = new UserFullInfo(databaseTools, bio);
	}

	@Override
	public String toString() {
		return new StringJoiner(", ", User.class.getSimpleName() + "[", "]")
						.add("firstName='" + firstName + "'")
						.add("username='" + username + "'")
						.add("fullInfo=" + fullInfo)
						.toString();
	}
}
