package it.cavallium.strangedb.tests;

import it.cavallium.strangedb.java.annotations.DbDataType;
import it.cavallium.strangedb.java.annotations.DbField;
import it.cavallium.strangedb.java.database.IDatabaseTools;
import it.cavallium.strangedb.java.objects.EnhancedObject;

import java.io.IOException;
import java.util.StringJoiner;

public class UserFullInfo extends EnhancedObject {

	@DbField(id = 0, name = "bio")
	public String bio;

	public UserFullInfo() {

	}

	public UserFullInfo(IDatabaseTools databaseTools, String bio) throws IOException {
		super(databaseTools);
		this.bio = bio;
	}

	@Override
	public String toString() {
		return new StringJoiner(", ", UserFullInfo.class.getSimpleName() + "[", "]")
						.add("bio='" + bio + "'")
						.toString();
	}
}
